From 0f0ec012180a2924e0dd631ad7f2dedfd31a8c3e Mon Sep 17 00:00:00 2001
From: =?UTF-8?q?Hugo=20Beauz=C3=A9e-Luyssen?= <beauze.h@gmail.com>
Date: Tue, 24 Jan 2012 00:06:41 +0100
Subject: [PATCH 05/11] bluray: Nasty hack to avoid crashing when changing
 title.

---
 modules/access/bluray.c |   17 +++++++++++++++--
 1 files changed, 15 insertions(+), 2 deletions(-)

diff --git a/modules/access/bluray.c b/modules/access/bluray.c
index c6a2243..6d8e1bd 100644
--- a/modules/access/bluray.c
+++ b/modules/access/bluray.c
@@ -300,8 +300,22 @@ static int blurayInitTitles(demux_t *p_demux )
     return VLC_SUCCESS;
 }
 
+static void blurayResetParser( demux_t *p_demux )
+{
+    demux_sys_t *p_sys = p_demux->p_sys;
+    if ( p_sys->p_parser )
+        stream_Delete( p_sys->p_parser );
+    p_sys->p_parser = stream_DemuxNew(p_demux, "ts", p_demux->out);
+    if (!p_sys->p_parser) {
+        msg_Err(p_demux, "Failed to create TS demuxer");
+    }
+}
+
 static void blurayUpdateTitle( demux_t *p_demux, int i_title )
 {
+    blurayResetParser( p_demux );
+    if ( i_title >= p_demux->p_sys->i_title )
+        return ;
     /* read title info and init some values */
     p_demux->info.i_title = i_title;
     p_demux->info.i_seekpoint = 0;
@@ -473,8 +487,7 @@ static void     blurayHandleEvent( demux_t *p_demux, const BD_EVENT *e )
     switch( e->event )
     {
         case BD_EVENT_TITLE:
-            if ( e->param < p_sys->i_title )
-                blurayUpdateTitle( p_demux, e->param );
+            blurayUpdateTitle( p_demux, e->param );
             break ;
         case BD_EVENT_PLAYITEM:
             break ;
-- 
1.7.8.4

